Subject: Re: [PATCH net v3 0/3] mptcp: Fix conflicts between MPTCP and sockmap

From: "Jiayuan Chen" <[email-masked]>
Date: Fri, 24 Oct 2025 04:13:13 +0000

2025/10/23 22:10, "Matthieu Baerts" <[email-masked] mailto:[email-masked]?to=%22Matthieu%20Baerts%22%20%3Cmatttbe%40kernel.org%3E > 写到:

> >  MPTCP creates subflows for data transmission between two endpoints.
> >  However, BPF can use sockops to perform additional operations when TCP
> >  completes the three-way handshake. The issue arose because we used sockmap
> >  in sockops, which replaces sk->sk_prot and some handlers.
> > 
> Do you know at what stage the sk->sk_prot is modified with sockmap? When
> switching to TCP_ESTABLISHED?
> Is it before or after having set "tcp_sk(sk)->is_mptcp = 0" (in
> subflow_ulp_fallback(), coming from subflow_syn_recv_sock() I suppose)?

Yes, there are two call points. One is after executing subflow_syn_recv_sock():
tcp_init_transfer(sk, BPF_SOCK_OPS_PASSIVE_ESTABLISHED_CB, skb);

So at this point, is_mptcp = 0. The other call point is when userspace calls
the BPF interface, passing in an fd while it's not a subflow but a parent sk
with its own mptcp_prot we will also reject it.

You can refer to my provided selftest, which covers these scenarios.

> If MPTCP is still being used (sk_is_tcp(sk) && sk_is_mptcp(sk)), I guess
> sockmap should never touch the in-kernel TCP subflows: they will likely
> only carry a part of the data. Instead, sockmap should act on the MPTCP
> sockets, not the in-kernel TCP subflows.

Yes, I agree.

For full functionality, we need to retrieve the parent socket from MPTCP
and integrate it with sockmap, rather than simply rejecting.

The current implementation rejects MPTCP because I previously attempted to
add sockmap support for MPTCP, but it required implementing many interfaces
and would take considerable time.

So for now, I'm proposing this as a fix to resolve the immediate issue.
Subsequently, we can continue working on fully integrating MPTCP with sockmap.

> There is one particular case to take into consideration: an MPTCP
> connection can fallback to "plain" TCP before being used by the
> userspace. Typically, that's when an MPTCP listening socket receives a
> "plain" TCP request (without MPTCP): a "plain" TCP socket will then be
> created, and exposed to the userspace. In this case, sk_is_mptcp(sk)
> will return false. I guess that's the case you are trying to handle,
> right? (It might help BPF reviewers to mention that in the commit
> message(s).)

Yes, this is primarily the case we're addressing. I will add this description
to the commit message.

> I would then say that sk->sk_prot->psock_update_sk_prot should not point
> to tcp_bpf_update_proto() when MPTCP is being used (or this callback
> should take the MPTCP case into account, but I guess no). In case of
> fallback before the accept() stage, the socket can then be used as a
> "plain" TCP one. I guess when tcp_bpf_update_proto() will be called,
> sk_prot is pointing to tcp(v6)_prot, not the MPTCP subflow override one,
> right?

Yes, when tcp_bpf_update_proto is called the sk_prot is pointing to tcp(v6)_prot.
subflow_syn_recv_sock
 mptcp_subflow_drop_ctx
  subflow_ulp_fallback
   mptcp_subflow_ops_undo_override -> reset sk_prot to original one

So [patch 2/3] aims to prevent psock_update_sk_prot from being executed on subflows.

Actually, replacing the subflow's callbacks is also incorrect, as you mentioned earlier,
because subflows only carry part of the data. By checking for subflows early and skipping
subsequent steps, we avoid incorrect logic.

Furthermore, there's another risk: if an IPv6 request comes in and we perform the replacement,
MPTCP will roll it back to inet_stream_ops. I haven't delved too deeply into the potential
impact, but I noticed that inet6_release has many V6-specific cleanup procedures not present
in inet_release.

> > 
> > Since subflows
> >  also have their own specialized handlers, this creates a conflict and leads
> >  to traffic failure. Therefore, we need to reject operations targeting
> >  subflows.
> > 
> Would it not work to set sk_prot->psock_update_sk_prot to NULL for the
> v4 and v6 subflows (in mptcp_subflow_init()) for the moment while
> sockmap is not supported with MPTCP? This might save you some checks in
> sock_map.c, no?

This seems like a reliable alternative I hadn't considered initially.

However, adding the check on the BPF side serves another purpose: to explicitly
warn users that sockmap and MPTCP are incompatible.

Since the latest Golang version enables MPTCP server by default, and if the client
doesn't support MPTCP, it falls back to TCP logic. We want to print a clear message
informing users who have upgraded to the latest Golang and are using sockmap.

Perhaps we could add a function like sk_is_mptcp_subflow() in the MPTCP side?
The implementation would simply be sk_is_tcp(sk) && sk_is_mptcp(sk).

Implementing this check logic on the BPF side might become invalid if MPTCP internals
change later; placing it in the MPTCP side might be a better choice.

> > 
> > This patchset simply prevents the combination of subflows and sockmap
> >  without changing any functionality.
> > 
> In your case, you have an MPTCP listening socket, but you receive a TCP
> request, right? The "sockmap update" is done when switching to
> TCP_ESTABLISHED, when !sk_is_mptcp(sk), but that's before
> mptcp_stream_accept(). That's why sk->sk_prot has been modified, but it
> is fine to look at sk_family, and return inet(6)_stream_ops, right?

I believe so. Since MPTCP is fundamentally based on TCP, using sk_family to
determine which ops to fall back to should be sufficient.

However, strictly speaking, this [patch 1/3] might not even be necessary if we
prevent the sk_prot replacement for subflows at the sockmap layer.

> A more important question: what will typically happen in your case if
> you receive an MPTCP request and sockmap is then not supported? Will the
> connection be rejected or stay in a strange state because the userspace
> will not expect that? In these cases, would it not be better to disallow
> sockmap usage while the MPTCP support is not available? The userspace
> would then get an error from the beginning that the protocol is not
> supported, and should then not create an MPTCP socket in this case for
> the moment, no?
>
> I can understand that the switch from TCP to MPTCP was probably done
> globally, and this transition should be as seamless as possible, but it
> should not cause a regression with MPTCP requests. An alternative could
> be to force a fallback to TCP when sockmap is used, even when an MPTCP
> request is received, but not sure if it is practical to do, and might be
> strange from the user point of view.

Actually, I understand this not as an MPTCP regression, but as a sockmap
regression.

Let me explain how users typically use sockmap:

Users typically create multiple sockets on a host and program using BPF+sockmap
to enable fast data redirection. This involves intercepting data sent or received
by one socket and redirecting it to the send or receive queue of another socket.

This requires explicit user programming. The goal is that when multiple microservices
on one host need to communicate, they can bypass most of the network stack and avoid
data copies between user and kernel space.

However, when an MPTCP request occurs, this redirection flow fails.

Since the sockmap workflow typically occurs after the three-way handshake, rolling
back at that point might be too late, and undoing the logic for MPTCP would be very
complex.

Regardless, the reality is that MPTCP and sockmap are already conflicting, and this
has been the case for some time. So I think our first step is to catch specific
behavior on the BPF side and print a message
"sockmap/sockhash: MPTCP sockets are not supported\n", informing users to either
stop using sockmap or not use MPTCP.

As for the logic to check for subflows, I think implementing it in subflow.c would be
beneficial, as this logic would likely be useful later if we want to
support MPTCP + sockmap.

Furthermore, this commit also addresses the issue of incorrectly selecting
inet_stream_ops due to the subflow prot replacement, as mentioned above.

> > 
> > A complete integration of MPTCP and sockmap would require more effort, for
> >  example, we would need to retrieve the parent socket from subflows in
> >  sockmap and implement handlers like read_skb.
> >  
> >  If maintainers don't object, we can further improve this in subsequent
> >  work.
> > 
> That would be great to add MPTCP support in sockmap! As mentioned above,
> this should be done on the MPTCP socket. I guess the TCP "in-kernel"
> subflows should not be modified.

I think we should first fix the issue by having sockmap reject operations on subflows.
Subsequently, we can work on fully integrating sockmap with MPTCP as a feature
(which would require implementing some handlers).

> > 
> > [1] truncated warning:
> >  [ 18.234652] ------------[ cut here ]------------
> >  [ 18.234664] WARNING: CPU: 1 PID: 388 at net/mptcp/protocol.c:68 mptcp_stream_accept+0x34c/0x380
> >  [ 18.234726] Modules linked in:
> >  [ 18.234755] RIP: 0010:mptcp_stream_accept+0x34c/0x380
> >  [ 18.234762] RSP: 0018:ffffc90000cf3cf8 EFLAGS: 00010202
[...]
> > 
> Please next time use the ./scripts/decode_stacktrace.sh if possible.
> (and strip the timestamps if it is not giving useful info)
> Just to be sure: is it the warning you get on top of net or net-next? Or
> an older version? (Always useful to mention the base)

Thank you, Matthieu. I will pay attention to this.

> > 
> > ---
> >  v2: https://lore.kernel.org/bpf/[email-masked]/T/#t
> >  Some advice suggested by Jakub Sitnicki
> >  
> >  v1: https://lore.kernel.org/mptcp/[email-masked]/T/#t
> >  Some advice from Matthieu Baerts.
> > 
> (It usually helps reviewers to add more details in the notes/changelog
> for the individual patch)

Thank you, Matthieu. I will provide more detailed descriptions in the future.

Best regards,
Jiayuan